your_project
============
[![build status](http://git.dms-serwis.com.pl/smok4/svcr/badges/master/build.svg)](http://git.dms-serwis.com.pl/henrietta/py-scaffold/commits/master)
[![coverage report](http://git.dms-serwis.com.pl/smok4/svcr/badges/master/coverage.svg)](http://git.dms-serwis.com.pl/henrietta/py-scaffold/commits/master)

This is a generic scaffold for Python projects that use:
* _GitLab CI_ for builds/tests/deploys
* _coverage.py_ for test coverage
* _nose_ for unit tests
* _Vagrant_ for environment
* _setuptools_ for packaging
* _git_ for version control

# How to use

1. `git clone http://git.dms-serwis.com.pl/henrietta/py-scaffold.git`
2. delete `.git` directory
3. Rename [your_project_source](your_project_source) to match your project
4. adjust [setup.py](setup.py), and optionally [setup.cfg](setup.cfg)
5. adjust [.coveragerc](.coveragerc)
6. adjust [license](LICENSE)
7. adjust or delete [contribution guide](CONTRIBUTING.md)
8. adjust or delete [change log](CHANGELOG.md)
9. adjust [Vagrantfile](Vagrantfile), or remove it
10. adjust [MANIFEST.in](MANIFEST.in) if you have data files
11. adjust [docs](docs/)
12. adjust [gitlab-ci.yml](.gitlab-ci.yml), especially if your tests require a 
    Vagrant environment
13. Set up a repository on GitLab
14. Ensure you have _master_ permission on this repository
15. Set `^TOTAL\s+\d+\s+\d+\s+\d+\s+\d+\s+(\d+)%$` in 
  _Settings>CI/CD Pipelines>Test coverage parsing_ for GitLab to display
  test coverage data
16. `git init`
17. Add suitable remotes, commit the data, push to repo
18. Done!

